import java.sql.*;
import java.util.*;
/** 
  Creates a database table that stores
  the result of the Byzantine election
  A Byzantine election is conducted
  for every blob starting from 0.
  The result is basically the machine_id
  that is the home for every blob

*/
  


public class VoterManagerImpl 
	extends java.rmi.server.UnicastRemoteObject
	implements VoterManager
{	
	private static final long serialVersionUID=1L;
	private boolean do_once = false;
	
	public VoterManagerImpl() throws java.rmi.RemoteException {

	}
	public Voter createVoter(int delay, 
				 boolean faulty, 
				 int vID,
				 int mcID,
				 Hashtable ht_blobMachine,
				 int[] blob_mcID,
				 String[] mcID_tIP,
				 String dbName, 
				 String user, 
				 String passwd, 
				 String tblName) 
		throws java.sql.SQLException, 
		ClassNotFoundException
	{
		// Create the table for all voters on this node
		Connection db;
		Statement sql;
		String sqlText;

		if (!do_once) {	
			do_once = true;
       			Class.forName("org.postgresql.Driver");
			db = DriverManager.getConnection("jdbc:postgresql://localhost/" + dbName, 
					  user, passwd);
			sql = db.createStatement();
			sqlText = "CREATE TABLE " + tblName 
				  + "(blob_id int, machine_id int)";
			sql.executeUpdate(sqlText);
			sql.close();
			db.close();
		}
	
		Voter v = new VoterByzantineImpl(delay, 
						 faulty,
						 vID,
						 mcID,
						 ht_blobMachine,
						 blob_mcID,
						 mcID_tIP);
		return v;
	}
	

}
