/**
 * VoterServer class
 * Creates a continuously running server that instantiates a
 * VoterManager RMI Object that can then accept incoming
 * RMI request to create a voter, or set properties of the voter
 *  
 * @Parameters: None
 * @Returns: None
 */

import java.rmi.*;
public class VoterServer {
	public VoterServer() {
		if (System.getSecurityManager() == null) {
			System.setSecurityManager(new RMISecurityManager());
		}
		try {
			VoterManager vmgr = new VoterManagerImpl();
			Naming.rebind("rmi://localhost/voteMgr", vmgr);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	public static void main(String[] args) {
		new VoterServer();
	}
	
}
