-- Use this file to insert XML records into tblP
-- Following are the arguments for the get_xml_data
-- function
-- Arg1: Name of the file that contains the XML records
-- Arg2: # of XML records in the file, whose location
-- 	 is specified in Arg1
-- Arg3: This is an OUT arg, that is populated by
--	 the parser that is implemented inside libproj6
--	 The parser populates this with the VoterID
--	 contained in each XML record
-- Arg4: The XML parser in libproj6 populates this with
--	 the blobID in the XML record

-- The INSERT statement basically inserts every shredded
-- XML record in file specified by Arg1, where the # of records
-- is specified by arg2. 
--
-- Author: Preethi Vishwanath
-- CS298 Thesis

DROP FUNCTION get_xml_data(text, integer);

CREATE OR REPLACE FUNCTION get_xml_data(IN text,
					IN integer, 
				       OUT voterID VARCHAR, 
				       OUT blobID VARCHAR
				       ) RETURNS SETOF record
	AS '/home/hlthantr/proj6/libproj6', 'get_xml_data'
	LANGUAGE C IMMUTABLE STRICT;

DROP TABLE tblP;
CREATE TABLE tblP(voter_id VARCHAR, blob_id VARCHAR);
INSERT INTO tblP VALUES ((get_xml_data('/home/hlthantr/proj6/config/voter1.xml', 4)).voterID, 
			 (get_xml_data('/home/hlthantr/proj6/config/voter1.xml', 4)).blobID
			 );
INSERT INTO tblP VALUES ((get_xml_data('/home/hlthantr/proj6/config/voter2.xml', 2)).voterID, 
			 (get_xml_data('/home/hlthantr/proj6/config/voter2.xml', 2)).blobID
			 );

INSERT INTO tblP VALUES ((get_xml_data('/home/hlthantr/proj6/config/voter3.xml', 4)).voterID, 
			 (get_xml_data('/home/hlthantr/proj6/config/voter3.xml', 4)).blobID
			 );

INSERT INTO tblP VALUES ((get_xml_data('/home/hlthantr/proj6/config/voter4.xml', 2)).voterID, 
			 (get_xml_data('/home/hlthantr/proj6/config/voter4.xml', 2)).blobID
			 );

INSERT INTO tblP VALUES ((get_xml_data('/home/hlthantr/proj6/config/voter5.xml', 4)).voterID, 
			 (get_xml_data('/home/hlthantr/proj6/config/voter5.xml', 4)).blobID
			 );

INSERT INTO tblP VALUES ((get_xml_data('/home/hlthantr/proj6/config/voter6.xml', 3)).voterID, 
			 (get_xml_data('/home/hlthantr/proj6/config/voter6.xml', 3)).blobID
			 );

INSERT INTO tblP VALUES ((get_xml_data('/home/hlthantr/proj6/config/voter7.xml', 2)).voterID, 
			 (get_xml_data('/home/hlthantr/proj6/config/voter7.xml', 2)).blobID
			 );

INSERT INTO tblP VALUES ((get_xml_data('/home/hlthantr/proj6/config/voter8.xml', 4)).voterID, 
			 (get_xml_data('/home/hlthantr/proj6/config/voter8.xml', 4)).blobID
			 );
INSERT INTO tblP VALUES ((get_xml_data('/home/hlthantr/proj6/config/voter9.xml', 4)).voterID, 
			 (get_xml_data('/home/hlthantr/proj6/config/voter9.xml', 4)).blobID
			 );
INSERT INTO tblP VALUES ((get_xml_data('/home/hlthantr/proj6/config/voter10.xml', 4)).voterID, 
			 (get_xml_data('/home/hlthantr/proj6/config/voter10.xml', 4)).blobID
			 );
INSERT INTO tblP VALUES ((get_xml_data('/home/hlthantr/proj6/config/voter11.xml', 4)).voterID, 
			 (get_xml_data('/home/hlthantr/proj6/config/voter11.xml', 4)).blobID
			 );
SELECT * FROM tblP;

